// VBConversions Note: VB project level imports
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using Microsoft.VisualBasic;
using System.Linq;
using System;
using System.Collections;
using System.Xml.Linq;
using System.Windows.Forms;
// End of VB project level imports

using System.Drawing.Printing;

namespace MergeDocuments
{
	public partial class Form1
	{
		public Form1()
		{
			InitializeComponent();
			
			//Added to support default instance behavour in C#
			if (defaultInstance == null)
				defaultInstance = this;
		}
		
#region Default Instance
		
		private static Form1 defaultInstance;
		
		/// <summary>
		/// Added by the VB.Net to C# Converter to support default instance behavour in C#
		/// </summary>
		public static Form1 Default
		{
			get
			{
				if (defaultInstance == null)
				{
					defaultInstance = new Form1();
					defaultInstance.FormClosed += new FormClosedEventHandler(defaultInstance_FormClosed);
				}
				
				return defaultInstance;
			}
		}
		
		static void defaultInstance_FormClosed(object sender, FormClosedEventArgs e)
		{
			defaultInstance = null;
		}
		
#endregion
		
		string[] arraylist;
		int lastindex;
		int len;
		string getname;
		string getext;
		
		
		public void btnBrowseRpt_Click(System.Object sender, System.EventArgs e)
		{
			Reportlist.Items.Clear();
			Reportlist.Enabled = false;
			lblSelectReport.Enabled = false;
			Reportlist.Text = "";
			OpenFileDialog1.Filter = "XML Files|*.xml";
			if (OpenFileDialog1.ShowDialog() == DialogResult.OK)
			{
				LoadReport();
			}
		}
		
		public void LoadReport()
		{
			try
			{
				tbReportDefName.Text = OpenFileDialog1.FileName;
				arraylist = C1Report1.GetReportInfo(OpenFileDialog1.FileName);
				arraylist.Count();
				for (var i = 0; i <= arraylist.Count()  - 1; i++)
				{
					Reportlist.Items.Add(arraylist[(int) i].ToString());
				}
				Reportlist.Enabled = true;
				lblSelectReport.Enabled = true;
				tbReportDefName.Enabled = true;
			}
			catch (Exception)
			{
				MessageBox.Show("Invalid Report File");
				tbReportDefName.Text = "";
				tbReportDefName.Enabled = false;
			}
		}
		
		public void btnBrowsePrintDoc_Click(System.Object sender, System.EventArgs e)
		{
			OpenFileDialog1.Filter = "c1d Files|*.c1d|c1dx Files|*.c1dx";
			if (OpenFileDialog1.ShowDialog() == DialogResult.OK)
			{
				LoadPrintDoc();
			}
		}
		
		public void LoadPrintDoc()
		{
			try
			{
				tbPrintDocName.Text = OpenFileDialog1.FileName;
				C1PrintDocument1.Load(OpenFileDialog1.FileName);
				tbPrintDocName.Enabled = true;
			}
			catch (Exception)
			{
				MessageBox.Show("Invalid Report File");
				tbPrintDocName.Text = "";
				tbPrintDocName.Enabled = false;
			}
			lastindex = OpenFileDialog1.FileName.LastIndexOf("\\");
			len = OpenFileDialog1.FileName.Length;
			getname = OpenFileDialog1.FileName.Substring(lastindex + 1, len - (lastindex + 1));
			RemoveExistingFile("doc");
			lbSelectedList.Items.Add("Doc: " + getname);
		}
		
		public void btnBrowseRDL_Click(System.Object sender, System.EventArgs e)
		{
			OpenFileDialog1.Filter = "rdl Files|*.rdl";
			if (OpenFileDialog1.ShowDialog() == DialogResult.OK)
			{
				LoadRdlReport();
			}
		}
		
		public void LoadRdlReport()
		{
			try
			{
				tbRDLRepName.Text = OpenFileDialog1.FileName;
				C1RdlReport1.Load(OpenFileDialog1.FileName);
				C1RdlReport1.Render();
				tbRDLRepName.Enabled = true;
			}
			catch (Exception)
			{
				MessageBox.Show("Invalid Report File");
				tbRDLRepName.Text = "";
				tbRDLRepName.Enabled = false;
			}
			lastindex = OpenFileDialog1.FileName.LastIndexOf("\\");
			len = OpenFileDialog1.FileName.Length;
			getname = OpenFileDialog1.FileName.Substring(lastindex + 1, len - (lastindex + 1));
			RemoveExistingFile("rdl");
			lbSelectedList.Items.Add("Rdl: " + getname);
		}
		
		public void btnMerge_Click(System.Object sender, System.EventArgs e)
		{
			MergeReports();
			C1PrintPreviewControl1.Document = C1MultiDocument1;
		}
		
		public void MergeReports()
		{
			C1MultiDocument1.Items.Add(C1Report1.C1Document);
			C1MultiDocument1.Items.Add(C1PrintDocument1);
			C1MultiDocument1.Items.Add(C1RdlReport1.C1Document);
		}
		
		public void Reportlist_SelectedIndexChanged(System.Object sender, System.EventArgs e)
		{
			try
			{
				C1Report1.Load(OpenFileDialog1.FileName.ToString(), (string) Reportlist.SelectedItem);
				RemoveExistingFile("rpt");
				lbSelectedList.Items.Add("Rpt: " + Reportlist.SelectedItem);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}
		
		public void btnReset_Click(System.Object sender, System.EventArgs e)
		{
			tbReportDefName.Text = "";
			Reportlist.Text = "";
			lblSelectReport.Enabled = false;
			Reportlist.Enabled = false;
			tbPrintDocName.Text = "";
			tbRDLRepName.Text = "";
			lbSelectedList.Items.Clear();
		}
		
		public void RemoveExistingFile(string ext)
		{
			if (lbSelectedList.Items.Count > 0)
			{
				foreach (var item in lbSelectedList.Items)
				{
					getext = (string) (item.ToString().Substring(0, 3));
					if (getext == "Rpt" && ext == "rpt")
					{
						lbSelectedList.Items.Remove(item);
					}
					else if (getext == "Doc" && ext == "doc")
					{
						lbSelectedList.Items.Remove(item);
					}
					else if (getext == "Rdl" && ext == "rdl")
					{
						lbSelectedList.Items.Remove(item);
					}
				}
			}
		}
		
	}
	
}
